Overview | Package | Class | Tree | Deprecated | Index | Help
| Copyright © 2006 BEA Systems, Inc. All Rights Reserved
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.bea.apps.groupspace.search.controls
Interface ExpressionSearchControl<T>

All Superinterfaces
  RepoSearchControl<T>, SearchControl<T>

All Known Subinterfaces:
  CmExpressionSearchControl, GsExpressionSearchControl<T>

    public interface ExpressionSearchControl<T>

extends RepoSearchControl<T>

Usage:

- optionally set the search path
- optionally set the object class to limit the search to
- construct the expression string, using the available logical operators, repo search fields, and/or properties
- execute the search using that expression

Method Summary
`com.bea.apps.groupspace.search.utils.ExpressionBuilder` | `getExpressionBuilder()` Return the ExpressionBuilder for use in constructing more comples expressions
`com.bea.p13n.pagination.SortableFilterablePagedResult<T>` | `search()` Search using the current criteria set on the control properties.
`com.bea.p13n.pagination.SortableFilterablePagedResult<T>` | `search(com.bea.p13n.expression.Expression expression)` Execute the search with the given Expression object
`com.bea.p13n.pagination.SortableFilterablePagedResult<T>` | `search(String expression)` Execute the search with the given expression
`Set<T>` | `searchAsSet()`
`Set<T>` | `searchAsSet(String exp)` Convenience method.
`com.bea.p13n.pagination.SortableFilterablePagedResult<T>` | `searchContains(String property, String criteria, boolean anywhere)` Find items whose property contains exactly this criteria.
`com.bea.p13n.pagination.SortableFilterablePagedResult<T>` | `searchContainsAll(String property, String[] criteria)` Find items whose property contains all of these criteria.
`com.bea.p13n.pagination.SortableFilterablePagedResult<T>` | `searchContainsAny(String property, String[] criteria)` Find items whose property contains any of these criteria.
`com.bea.p13n.pagination.SortableFilterablePagedResult<T>` | `searchCount(String property, int count, com.bea.apps.groupspace.search.utils.ExpressionBuilder.CountCriteria criteria)` Construct the Expression to limit based on count.
`com.bea.p13n.pagination.SortableFilterablePagedResult<T>` | `searchDate(String property, String date, com.bea.apps.groupspace.search.utils.ExpressionBuilder.DateCriteria criteria)` Construct the Expression to limit the date of the search.
`com.bea.p13n.pagination.SortableFilterablePagedResult<T>` | `searchEquals(String property, String criteria)` Include this property in the search.
`T` | `searchForOne(String exp)` Convenience method
`com.bea.p13n.pagination.SortableFilterablePagedResult<T>` | `searchLike(String property, String criteria, boolean ignoreCase)` Find items whose property contains something similar to this criteria.
`com.bea.p13n.pagination.SortableFilterablePagedResult<T>` | `searchNot(String property, String criteria)` Excludes this property from the search.
`void` | `setExcludeObjectClassNames(String[] ocNames)` Exclude these ObjectClasses from the search.

Methods inherited from interface com.bea.apps.groupspace.search.controls.RepoSearchControl
`getAvailableObjectClasses, getObjectClassProperties, getObjectClassPropertyDefinitions, setSearchPath, setSearchPaths`

Methods inherited from interface com.bea.apps.groupspace.search.controls.SearchControl
`asList, asSet, flushSearchCache, getSortCriteria, setSortCriteria`

Method Detail

### searchForOne

    T searchForOne(String exp)
                   throws Exception

  Convenience method

  Throws
    `Exception`

### searchAsSet

    Set<T> searchAsSet(String exp)
                       throws Exception

  Convenience method.

  Throws
    `Exception`

### searchAsSet

    Set<T> searchAsSet()
                       throws Exception

  Throws
    `Exception`

### search

    com.bea.p13n.pagination.SortableFilterablePagedResult<T> search()
                                                                    throws Exception

  Search using the current criteria set on the control properties. Returns null if nothing found.

  Throws
    `Exception`

### getExpressionBuilder

    com.bea.apps.groupspace.search.utils.ExpressionBuilder getExpressionBuilder()

  Return the ExpressionBuilder for use in constructing more comples expressions

### searchDate

    com.bea.p13n.pagination.SortableFilterablePagedResult<T> searchDate(String property,
                                                                        String date,
                                                                        com.bea.apps.groupspace.search.utils.ExpressionBuilder.DateCriteria criteria)
                                                                        throws Exception

  Construct the Expression to limit the date of the search. For example, to find all books published before Jan 12, 2004: dateCriteria("pub_date", DateCriteria.BEFORE)

  Throws
    `Exception`

### searchCount

    com.bea.p13n.pagination.SortableFilterablePagedResult<T> searchCount(String property,
                                                                         int count,
                                                                         com.bea.apps.groupspace.search.utils.ExpressionBuilder.CountCriteria criteria)
                                                                         throws Exception

  Construct the Expression to limit based on count. For example, to retrieve items with the 'viewed' property value of 'less than three': countCriteria("viewed", 3, CountCriteria.LT);

  Throws
    `Exception`

### searchNot

    com.bea.p13n.pagination.SortableFilterablePagedResult<T> searchNot(String property,
                                                                       String criteria)
                                                                       throws Exception

  Excludes this property from the search. For example, to find all items where the 'genre' property is not 'mystery': not("genre", "mystery")

  Throws
    `Exception`

### searchEquals

    com.bea.p13n.pagination.SortableFilterablePagedResult<T> searchEquals(String property,
                                                                          String criteria)
                                                                          throws Exception

  Include this property in the search. For example, to find all items where the 'genre' property is equal to 'mystery': equals("genre", "mystery")

  Throws
    `Exception`

### searchContains

    com.bea.p13n.pagination.SortableFilterablePagedResult<T> searchContains(String property,
                                                                            String criteria,
                                                                            boolean anywhere)
                                                                            throws Exception

  Find items whose property contains exactly this criteria. Wildcards are not allowed; use the "like" construct for that. If "anywhere" is set to true, then the word will be searched for anywhere in the content. This means 'pen' will match "pen", " pencil", "open ", and "opening". In this case, it's probably best to use a full text search control.

  Throws
    `Exception`

### searchContainsAll

    com.bea.p13n.pagination.SortableFilterablePagedResult<T> searchContainsAll(String property,
                                                                               String[] criteria)
                                                                               throws Exception

  Find items whose property contains all of these criteria. Wildcards are not allowed; use the "like" construct for that.

  Throws
    `Exception`

### searchContainsAny

    com.bea.p13n.pagination.SortableFilterablePagedResult<T> searchContainsAny(String property,
                                                                               String[] criteria)
                                                                               throws Exception

  Find items whose property contains any of these criteria. Wildcards are not allowed; use the "like" construct for that. If multiple criteria, separate them by commas.

  Throws
    `Exception`

### searchLike

    com.bea.p13n.pagination.SortableFilterablePagedResult<T> searchLike(String property,
                                                                        String criteria,
                                                                        boolean ignoreCase)
                                                                        throws Exception

  Find items whose property contains something similar to this criteria. Wildcards are allowed.

  Throws
    `Exception`

### search

    com.bea.p13n.pagination.SortableFilterablePagedResult<T> search(String expression)
                                                                    throws Exception

  Execute the search with the given expression

  Throws
    `Exception`

### search

    com.bea.p13n.pagination.SortableFilterablePagedResult<T> search(com.bea.p13n.expression.Expression expression)
                                                                    throws Exception

  Execute the search with the given Expression object

  Throws
    `Exception`

### setExcludeObjectClassNames

    void setExcludeObjectClassNames(String[] ocNames)

  Exclude these ObjectClasses from the search. This is a comma-separated list of ObjectClass names, eg: "LINK", "ISSUE". Note also you can restrict the search to include only a single ObjectClass, by using the objectClassName() property above. Then all others will be excluded from the search.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006 BEA Systems, Inc. All Rights Reserved